//
//  VideoSansAutoViewController.m
//  PokktManager
//
//  Created by Pokkt on 3/11/15.
//  Copyright (c) 2015 Pokkt. All rights reserved.
//

#import "VideoSansAutoViewController.h"
#import "AppDelegate.h"
#import "PokktManager.h"
#import "PokktController.h"
#import "VideoResponse.h"
#import "PokktConfig.h"

#define ErnedPoints @"Points"
#define userDefaluts [NSUserDefaults standardUserDefaults]

@interface VideoSansAutoViewController ()<PokktDelegate>
@property (nonatomic, strong) AppDelegate *appdelegate;

@property (nonatomic, strong) PokktConfig *pokktConfig;

@property (nonatomic) int point;

@end

@implementation VideoSansAutoViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    self.pokktConfig  = [[PokktConfig alloc]init];
    
    self.pokktConfig.applicationId = @"a2717a45b835b5e9f50284a38d62a74e";
    self.pokktConfig.securityKey = @"iJ02lJss0M";
    self.pokktConfig.thirdPartyUserId = @"123456";
    self.pokktConfig.autoCacheVideo = NO;
    self.pokktConfig.incentivised = YES;
    self.pokktConfig.skipEnabled = YES;
    self.pokktConfig.defaultSkipTime = 10;

    [PokktManager setDebug: YES];
    [PokktManager initPokkt:self.pokktConfig];
    [PokktManager setPokktDelegate:self];
    [PokktManager setPresentView:self];

    [self updatepointsEarned];

}

-(void)viewWillAppear:(BOOL)animated{
    [super viewWillAppear:animated];
    [self.navigationController setNavigationBarHidden:YES];   //it hides
    if (![PokktManager isVideoAvailable])
    {
        [self showButton:NO];
    }
    else
    {
        [self showButton:YES];
    }
}

-(void)viewWillDisappear:(BOOL)animated{
    [super viewWillDisappear:animated];
    [self.navigationController setNavigationBarHidden:NO];    // it shows
    
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Button Action

- (IBAction)videoButtonActions:(UIButton *)sender {
    if (sender.tag == 1)
    {
        [self checkVideoCache];
    }
    else if (sender.tag == 2)
    {
        [PokktManager playVideoCampaign:self.pokktConfig];
    }
    else if (sender.tag == 3)
    {
        self.pokktConfig.incentivised = NO;
        [PokktManager playVideoCampaign:self.pokktConfig];
    }
    else if(sender.tag == 4)
    {
        if (![PokktManager isVideoAvailable])
        {
            [self performSegueWithIdentifier:@"StaticPage" sender:self];
        }
        else
        {
            self.pokktConfig.incentivised = NO;
            [PokktManager playVideoCampaign:self.pokktConfig];
        }
    }
    else
    {
        [PokktManager exportPokktSDKLog];
    }
}

- (void)checkVideoCache {
    if (![PokktManager isVideoAvailable])
    {
        [PokktManager cacheVideoCampaign:self.pokktConfig];
    }
    else
    {
        [self showButton:YES];
        [PokktManager cacheVideoCampaign:self.pokktConfig];
    }
}

- (void)showButton:(BOOL)show {
    self.incentVdoBtn.hidden = !show;
    self.nonIncentVdoBtn.hidden = !show;
}

#pragma mark - Private Methods 

- (void)updatepointsEarned {
    if([userDefaluts objectForKey:ErnedPoints]) {
        self.point = [[userDefaluts objectForKey:ErnedPoints] intValue];
        self.pointNumLbl.text = [NSString stringWithFormat:@"Points earned : %d",self.point];
    }
}

- (void)showAlertWithMessage:(NSString *)msg {
    UIAlertView *alert = [[UIAlertView alloc]initWithTitle:@"" message:msg delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
    [alert show];
}

#pragma mark - Pokkt Delegates 

- (void)didFinishedVideoDownload:(BOOL)isFinished {
    [self showButton:YES];
    [self.incentVdoBtn setTitle:[NSString stringWithFormat:@"Play Incent Vdo To Earn %.2f",[PokktManager getVideoVc]] forState:UIControlStateNormal];
}

- (void)didFailedVideoDownload:(NSString *)error {
    [self showButton:NO];
}

- (void)onVideoClosed:(BOOL)isClosed {
    [self showAlertWithMessage:@"Video is closed"];
}

- (void)onVideoCompleated:(BOOL)isCompleated {
    [self showAlertWithMessage:@"Video is compleated"];
}

- (void)onVideoDisplayed  {
    [self showAlertWithMessage:@"Video is displayed"];
}

- (void)onVideoGratified:(VideoResponse *)videoResponse {
    if([userDefaluts objectForKey:ErnedPoints]) {
        self.point = [[userDefaluts objectForKey:ErnedPoints] intValue];
    }
    if (videoResponse.coins) {
        self.point += [videoResponse.coins intValue];
        [userDefaluts setValue:[NSString stringWithFormat:@"%d",self.point] forKey:ErnedPoints];
        [userDefaluts synchronize];
        [self updatepointsEarned];
    }
    
}

- (void)onVideoSkiped {
    [self showAlertWithMessage:@"Video is skip"];
}

- (void)onVideoClosed {
    [self showAlertWithMessage:@"Video is closed"];
    
}

#pragma mark - Orienation

- (UIInterfaceOrientationMask)supportedInterfaceOrientations
{
    if (self.appdelegate.deviceType == iPhone4s || self.appdelegate.deviceType == iPhone5 || self.appdelegate.deviceType == iPhone5s) {
        return UIInterfaceOrientationMaskPortrait;
    }
    return UIInterfaceOrientationMaskAll;
}

@end
